function acctCtrl($ionicViewSwitcher, $scope, $state, $timeout, $http, $ionicModal, $ionicPopup, $ionicLoading, $ionicHistory, CommomService, $filter, ionicDatePicker) {

	$scope.cHeight = $scope.showSubStores ? hasSubHeight : defaultHeight + 35;
	$scope.seller = seller;
	$scope.store = {};
	$scope.account = {};
	$scope.user = {};
	$scope.data = {};

	$scope.$on("$ionicView.leave", function() {
		if(pwdPopup && pwdPopup != null) pwdPopup.close();
		ionicDatePicker.close();
	});
	/*
	 *返回上一页
	 */
	$scope.goBack = function () {
		$state.go("app.main");
		$ionicViewSwitcher.nextDirection("back");
	};
	
	$scope.doRefresh = function () {
		$scope.loadData();
		$scope.$broadcast('scroll.refreshComplete');
	};

	$scope.$on('$ionicView.afterEnter', function() {
		$scope.loadData();
	});

	$scope.loadData = function () {
		checkLogin().then(function(result) {
			showLoading("正在加载数据，请稍后...");
		
			var url = webHost + 'api/vboss/acct';
			$http.get(url).success(function(data) {
				$scope.$broadcast('scroll.refreshComplete');
				if (data.code == 0) {
					$scope.store = data.data.store;
					$scope.account = data.data.account;		
					$scope.user = data.data.user;	
				}
			}).error(function (result) {
				$scope.$broadcast('scroll.refreshComplete');
			});
		});
	};

	$scope.savePwd = function() {
		if(!$scope.data.oldPwd || $scope.data.oldPwd == '') {
			showToast($ionicLoading,"原密码不能为空");		
			return;
		}

		if(!$scope.data.newPwd || $scope.data.newPwd == '') {
			showToast($ionicLoading, "新密码不能为空");			
			$timeout(function() {
				$("#newPwd").focus();
			}, 1200);	
			return;
		}

		if(!$scope.data.comfirmPwd || $scope.data.comfirmPwd == '') {
			showToast($ionicLoading, "确认密码不能为空");
			$timeout(function() {
				$("#comfirmPwd").focus();
			}, 1200);	
			return;
		}

		if($scope.data.newPwd != $scope.data.comfirmPwd) {
			showToast($ionicLoading, "确认密码不正确");
			$timeout(function() {
				$("#comfirmPwd").focus();
			}, 1200);	
			return;
		}

		checkLogin().then(function(result) {					

			showLoading("正在加载数据，请稍后...");

			var dataJson = {
				'oldPassword': $scope.data.oldPwd,
				'newPassword': $scope.data.newPwd
			};

			var options = {
				headers: {
					'Authorization': "Bearer " + loginToken.accessToken,
					'jktranstionid': "vb-" + loginToken.storeCode + "-" + new Date().format("yyyyMMddhhmmsss") + "-" + Math.ceil(Math.random() * 10000),
					'Content-Type': 'application/json;charset=UTF-8'
				}
			}

			var url = webHost + 'api/user/changePwd';
			$http.post(url, angular.toJson(dataJson), options).success(function(data) {
				$scope.$broadcast('scroll.refreshComplete');
				if (data.code == 0) {
					showLoading("修改密码成功，请重新登录");
					$scope.data = {};
					if(pwdPopup && pwdPopup != null) pwdPopup.close();
					$timeout(function(){
						returnLogin();
					}, 1000);
				}
			}).error(function (result) {
				$scope.$broadcast('scroll.refreshComplete');
			});
		});
	};

	$scope.showPwd = function () {
		$scope.showPwdPopup();
	}

	var pwdPopup = null;
	$scope.showPwdPopup = function () {
		pwdPopup = $ionicPopup.show({
			title: '修改密码',
			cssClass: 'vboss_search_popup',
			templateUrl: 'js/acct/popup_acct.html',
			scope: $scope,
			buttons: [
				{
					text: '取消',
					type: 'button-cancle',
					onTap: function(e) {
						$scope.data = {};
					  	return true;
					}
				},
				{
					text: '确定',
					type: 'button-ok',
					onTap: function(e) {
					  $scope.savePwd();
					  e.preventDefault();
					}
				}
			]
		});
		pwdPopup.then(function (res) {			
		});
		$timeout(function() {
			$("#oldPwd").focus();
		}, 500);
	};
}
