//数据库文件
var localFileName = "edgesellerapp.db", fgDB;
var webHost;
var rootScope;
var handler = {
	ionicPlatform : null,
	http : null,
	ionicPopup : null,
	timeout : null,
	state : null,
	ionicModal : null,
	ionicLoading : null,
	navigator:null,
	q: null
}
var winHeight=window.screen.availHeight;
var seller = {
	userName : null,
	password : null	
};
var loginToken = {	
	storeId: null,
	storeCode: null,
	storeName: null,	
	storeType: null,
	addres: null,	
	accessToken: null,
	expiresIn: null,
	refreshToken: null,
	selStoreId:null,
	subStoreInfoList:null,
	lastestlogtime: null
};
var handlerPromise = {
	ionicPopupPromise: null,
	ionicLoadingPromise: null,
	ionicPopupPriority: 0
};

var noauthOptions = {
	headers: {
		'Authorization': 'Basic cGlnOmY3NGM2YWY0NmE3OGJlY2IyZjFiZDNmOTViYmQ1ODU4'
	}
};

var jsonNoauthOptions = {
	headers: {
		'Authorization': 'Basic cGlnOmY3NGM2YWY0NmE3OGJlY2IyZjFiZDNmOTViYmQ1ODU4',
		'Content-Type': 'application/json;charset=UTF-8'
	}
};

function checkLogin() {
	var deferred = handler.q.defer();
	var refreshNum = (loginToken.expiresIn - 300) * 1000;
	var loginNum = loginToken.expiresIn * 1000;
	var lastLoginTime = Date.parse(loginToken.lastestlogtime.replace(/-+/g,'/'));
	var refreshTime = lastLoginTime + refreshNum;
	var loginTime = lastLoginTime + loginNum;
	if(loginTime < new Date().getTime()) {
		login().then(function(result) {
			deferred.resolve(result);
		},function(result) {
			deferred.reject(result);
			if(result == 0) {
				showToast(handler.ionicLoading, '您的登录已过期，请重新登录!');
			} else if(result == 1) {
				showToast(handler.ionicLoading, '您不是付费账号，请付费激活!');
			} else if(result == 2) {
				showToast(handler.ionicLoading, '您的账号已过期，请续费激活!');
			}
			returnLogin();
		});
	} else if(refreshTime < new Date().getTime()) {
		refreshToken().then(function(result) {
			deferred.resolve(result);
		},function(result) {
			login().then(function(result) {
				deferred.resolve(result);
			},function(result) {
				deferred.reject(result);
				if(result == 0) {	
					showToast(handler.ionicLoading, '您的登录已过期，请重新登录!');
				} else if(result == 1) {
					showToast(handler.ionicLoading, '您不是付费账号，请付费激活!');
				} else if(result == 2) {
					showToast(handler.ionicLoading, '您的账号已过期，请续费激活!');
				}
				returnLogin();
			});
		});
	} else {
		deferred.resolve(1);
	}
	return deferred.promise;
}

function returnLogin() {
	seller = {};
	loginToken = {};
	resetRootData();
	handler.state.go("login");
	SellerDao.deleteAllSeller();
	rootScope.timeParams = new Date().format('yyyy-MM-dd');
}

function login() {
	var deferred= handler.q.defer();

	var randomStr = Math.ceil(Math.random() * 100000) + Date.now() ;

	var loginData = {
		"username": seller.userName,
		"password": seller.password,
		"randomStr": randomStr
	};	

	var url = ucHost + '/ucenter/getToken';
	handler.http.post(url, angular.toJson(loginData, true), jsonNoauthOptions).success(function(data) {
		console.log(data);
		if (data.code == 0) {
			loginToken.lastestlogtime = new Date().format("yyyy-MM-dd hh:mm:ss");
			loginToken.accessToken = data.data.access_token;
			loginToken.expiresIn = data.data.expires_in;
			loginToken.refreshToken = data.data.refresh_token;
			webHost = data.data.apos_api_domain;
			if(appHost && appHost != '') {
				webHost = appHost;
			}
			loginToken.storeCode = seller.userName;
			
			getUserInfo().then(function(result) {
				deferred.resolve(result);
			}, function(result) {
				deferred.reject(result);
			});
			
		} else {
			deferred.reject(0);
		}
	}).error(function(data) {
		deferred.reject(0);
	});

	return deferred.promise;
}

function refreshToken() {
	var deferred= handler.q.defer();

	var refreshData = {
		"grant_type": 'refresh_token',
		"refresh_token": loginToken.refreshToken
	};
	
	var url = webHost + 'auth/oauth/token';
	handler.http.post(url, refreshData, noauthOptions).success(function(data) {
		console.log(data);
		if (data.access_token) {
			loginToken.lastestlogtime = new Date().format("yyyy-MM-dd hh:mm:ss");
			loginToken.accessToken = data.access_token;
			loginToken.expiresIn = data.expires_in;
			loginToken.refreshToken = data.refresh_token;		

			getUserInfo().then(function(result) {
				deferred.resolve(result);
			}, function(result) {
				deferred.reject(result);
			});
			
		} else {
			deferred.reject(0);
		}
	}).error(function(data) {
		deferred.reject(0);
	});

	return deferred.promise;
}

function getUserInfo() {

	var deferred= handler.q.defer();
	
	var url = webHost + 'api/vboss/getstoreinfo';

	handler.http.get(url).success(function(data) {
		console.log(data);
		if (data.code == 0) {
			if(data.data.nonVip) {
				deferred.reject(1);
			} else if(data.data.isExpire) {
				deferred.reject(2);
			} else {
				loginToken.storeId = data.data.store.id;
				loginToken.storeName = data.data.store.storeName;
				loginToken.storeType = data.data.store.storeType;
				loginToken.addres = data.data.store.addres;
				loginToken.storeCode = data.data.store.StoreSysCode;
				loginToken.subStoreInfoList = data.data.subStores;
				
				rootScope.seller = seller;

				SellerDao.deleteAllSeller();
				SellerDao.addSeller(seller);
				deferred.resolve(1);
			}
		} else {
			deferred.reject(0);
		}
	}).error(function(data) {
		deferred.reject(0);
	});
	return deferred.promise;
}

function resetRootData() {
	if(typeof rootScope == 'undefined') return;
	rootScope.employeeList = null;
	rootScope.commodityTypeList = null;
	rootScope.supplierInfoList = null;
	rootScope.selStoreId = null;
	rootScope.selStoreName = null;
	rootScope.selStoreType = null;
	rootScope.dataCache = null;
	rootScope.timeParams = new Date().format('yyyy-MM-dd');
}

function initFGdb() {
	fgDB.transaction(function(tx) {
		// tx.executeSql('DROP TABLE IF EXISTS version');
		// tx.executeSql('DROP TABLE IF EXISTS seller');
		// tx.executeSql('CREATE TABLE IF NOT EXISTS [version] ([id] INTEGER PRIMARY KEY AUTOINCREMENT, [versionCode] VARCHAR2(10))');
		tx.executeSql('CREATE TABLE IF NOT EXISTS [seller] ([userName] VARCHAR2(64), [password] VARCHAR2(50))');
	}, function() {
		//alert('初始化表成功');
	}, function(er) {
		if (er) {
			showToast("初始化数据库失败");
			console.log('error with executeSql', er);
		}
	});
}


// angular.module is a global place for creating, registering and retrieving Angular modules
// 'starter' is the name of this angular module example (also set in a <body> attribute in index.html)
// the 2nd parameter is an array of 'requires'
// 'starter.controllers' is found in controllers.js
angular.module('starter', ['ionic', 'starter.controllers', 'starter.services', 'starter.directives', 'ngCordova'])
	.factory('httpInterceptor',['$q','$injector', function($q, $injector) {
		return {
			responseError : function(err) {
				$injector.get('$ionicLoading').hide();
				var error = '当前服务出错了，请稍后再试';
				if(err.status == 400) {
					showAlert('出错了', err.data.error_description);
					error = err.data.error_description;
				} else if(err.status == 401) {
					error = '用户名不存在或者密码错误';
				} else if(err.status == 0) {
					error = '连接服务器失败，请确认网络服务是否打开';
				}
				$injector.get('$ionicLoading').show({template: error, noBackdrop: true, duration: 1500});
				return $q.reject(err);
			},
			response : function(res) {
				$injector.get('$ionicLoading').hide();
				if(res.data.code == 1) {
					$injector.get('$ionicLoading').show({template: res.data.msg, noBackdrop: true, duration: 1500});
				}						
				return res;
			},
			request : function(config) {
				config.headers = config.headers || {};
				if(!config.headers["Authorization"]) {
					$injector.get('$ionicLoading').show({
						template : '正在加载数据，请稍后...'
					});
					config.headers["Authorization"] = "Bearer " + loginToken.accessToken;
					config.headers["jktranstionid"] = "vb-" + loginToken.storeCode + "-" + new Date().format("yyyyMMddhhmmsss") + "-" + Math.ceil(Math.random() * 10000);				
				};
				return config;
			},
			requestError : function(err) {
				$injector.get('$ionicLoading').hide();
				$injector.get('$ionicLoading').show({template: '连接服务器失败，请确认网络服务是否打开', noBackdrop: true, duration: 1500});
				return $q.reject(err);
			}
		};
	}])
	.config(["$stateProvider", "$urlRouterProvider", "$compileProvider","$ionicConfigProvider","$httpProvider", 
			function($stateProvider, $urlRouterProvider, $compileProvider,$ionicConfigProvider,$httpProvider) {
	
		$compileProvider.aHrefSanitizationWhitelist(/^\s*(https?|ftp|mailto|file|ghttps?|ms-appx|x-wmapp0):/);
		$ionicConfigProvider.views.swipeBackEnabled(false);
		$httpProvider.defaults.headers.put['Content-Type'] = 'application/x-www-form-urlencoded;charset=UTF-8';
		$httpProvider.defaults.headers.post['Content-Type'] = 'application/x-www-form-urlencoded;charset=UTF-8';
		//add httpInterceptor
		$httpProvider.interceptors.push('httpInterceptor');

		// Override $http service's default transformRequest
		$httpProvider.defaults.transformRequest = [function(data) {
			/**
			 * The workhorse; converts an object to x-www-form-urlencoded serialization.
			 * @param {Object} obj
			 * @return {String}
			 */
			var param = function(obj) {
				var query = '';
				var name, value, fullSubName, subName, subValue, innerObj, i;

				for (name in obj) {
					value = obj[name];

					if (value instanceof Array) {
						for (i = 0; i < value.length; ++i) {
							subValue = value[i];
							fullSubName = name + '[' + i + ']';
							innerObj = {};
							innerObj[fullSubName] = subValue;
							query += param(innerObj) + '&';
						}
					} else if (value instanceof Object) {
						for (subName in value) {
							subValue = value[subName];
							fullSubName = name + '[' + subName + ']';
							innerObj = {};
							innerObj[fullSubName] = subValue;
							query += param(innerObj) + '&';
						}
					} else if (value !== undefined && value !== null) {
						query += encodeURIComponent(name) + '='
							+ encodeURIComponent(value) + '&';
					}
				}

				return query.length ? query.substr(0, query.length - 1) : query;
			};

			return angular.isObject(data) && String(data) !== '[object File]'
				? param(data)
				: data;
		}];


		$stateProvider.state('login', {
			url: "/login",
			cache: false,
			templateUrl: "js/login/login.html"
		}).state('rjbb', {
			url: '/rjbb',
			cache: false,
			templateUrl: 'js/rjbb/rjbb.html'
		}).state('xsdj', {
			url: '/xsdj',
			cache: false,
			templateUrl: 'js/xsdj/xsdj.html'
		}).state('spxs', {
			url: '/spxs',
			cache: false,
			templateUrl: 'js/spxs/spxs.html'
		}).state('chzh', {
			url: '/chzh',
			cache: false,
			templateUrl: 'js/chzh/chzh.html'
		}).state('qsfx', {
			url: '/qsfx',
			cache: false,
			templateUrl: 'js/qsfx/qsfx.html'
		}).state('zbtj', {
			url: '/zbtj',
			cache: false,
			templateUrl: 'js/zbtj/zbtj.html'
		}).state('msgs', {
			url: '/msgs',
			cache: false,
			templateUrl: 'js/msgs/msgs.html'
		}).state('handover', {
			url: '/handover',
			cache: false,
			templateUrl: 'js/handover/handover.html'
		}).state('yyhz', {
			url: '/yyhz',
			cache: false,
			templateUrl: 'js/yyhz/yyhz.html'
		}).state('about', {
			url: '/about',
			cache: false,
			templateUrl: 'js/about/about.html'
		}).state('acct', {
			url: '/acct',
			cache: false,
			templateUrl: 'js/acct/acct.html'
		}).state('logs', {
			url: '/logs',
			cache: false,
			templateUrl: 'js/logs/logs.html'
		}).state('app', {
			url: '/app',
			abstract: true,
			templateUrl: 'templates/menu.html',
			controller: 'AppCtrl'
		}).state('app.search', {
			url: '/search',
			views: {
				'menuContent': {
					templateUrl: 'templates/search.html'
				}
			}
		}).state('app.main', {
			url: '/main',
			cache: false,
			views: {
				'menuContent': {
					templateUrl: 'templates/main.html'
				}
			}
		});
		// if none of the above states are matched, use this as the fallback

		$urlRouterProvider.otherwise('/login');
	}])
	.run(["$ionicPlatform", "$state", "$http", "$q", "$ionicModal", "$ionicPopup", "$timeout", "$document", "$rootScope", "$ionicLoading", "$location", "$ionicHistory",  "$cordovaFile", "$cordovaFileTransfer", "$cordovaFileOpener2", "$ionicScrollDelegate", "$ionicViewSwitcher","$cordovaToast",
		function($ionicPlatform, $state, $http, $q, $ionicModal, $ionicPopup, $timeout, $document, $rootScope, $ionicLoading,$location,$ionicHistory, $cordovaFile, $cordovaFileTransfer, $cordovaFileOpener2, $ionicScrollDelegate, $ionicViewSwitcher, $cordovaToast) {
		$ionicPlatform.ready(function() {
			// Hide the accessory bar by default (remove this to show the accessory bar above the keyboard
			// for form inputs)
			winHeight=window.screen.availHeight;
			if (window.cordova && window.cordova.plugins.Keyboard) {
				cordova.plugins.Keyboard.hideKeyboardAccessoryBar(false);
				cordova.plugins.Keyboard.disableScroll(true);				
			}

			// if (window.StatusBar) {
			// 	// org.apache.cordova.statusbar required
			// 	StatusBar.styleDefault();
			// }
			fgDB = new sqliteDB(localFileName, 1024 * 1024 * 10);
			initFGdb();
			handler = {
				ionicPlatform : $ionicPlatform,
				http : $http,
				ionicPopup : $ionicPopup,
				timeout : $timeout,
				state : $state,
				ionicModal : $ionicModal,
				ionicLoading : $ionicLoading,
				navigator: navigator,
				q:$q
			}
			rootScope = $rootScope;
			rootScope.onclickCheckUpdate = false;
			rootScope.versionShow = version;
			rootScope.timeParams =  new Date().format("yyyy-MM-dd");
			rootScope.checkUpdate = checkUpdate;

			SellerDao.getLocalUser(function(success, sellerItem) {
				hideLoading();
				if (success && sellerItem) {
					seller.userName = sellerItem.userName;
					seller.password = sellerItem.password;

					showLoading("正在加载数据，请稍后...");

					if(seller.userName && seller.password) {
						login().then(function(result) {
							resetRootData();  // 重设数据
							rootScope.selStoreId = loginToken.storeId;
							rootScope.selStoreName = loginToken.storeName;
							rootScope.selStoreType = loginToken.storeType;
							$state.go("app.main");
					
							rootScope.checkUpdate(false).then(function(result) {
							});
						}, function(error) {
							returnLogin();

							rootScope.checkUpdate(false).then(function(result) {
							});
						});
					} else {
						returnLogin();	

						rootScope.checkUpdate(false).then(function(result) {
						});
					}
				} else {
					returnLogin();

					rootScope.checkUpdate(false).then(function(result) {
					});
				}
			});

			rootScope.scrollTop = function(scrollHandler) {
				if(typeof $ionicScrollDelegate == 'undefined') return;
				if($ionicScrollDelegate == null) return;
				$ionicScrollDelegate.$getByHandle(scrollHandler).scrollTop();
			}			
		});

		function checkUpdate(isHint) {
			var deferred = $q.defer();
			if(!window.cordova) {
				deferred.resolve(false);
				return deferred.promise;
			}
			checkLastestVersion(version, isHint).then(function(result) {
				deferred.resolve(result);
			});
			return deferred.promise;
		}
		
		function checkLastestVersion(versionCode, isHint) {
			var deferred = $q.defer();
			
			showLoading("正在检测更新, 请稍后...");  

			var url = ucHost;
			if(ionic.Platform.platform() == 'android') { //android更新本地下载
				url += '/ucenter/VerMgr/version/vboss-apk';
			} else if(ionic.Platform.platform() == 'ios') { //ios跳转到appstore
				url += '/ucenter/VerMgr/version/vboss-ios';
			}

			$http.get(url, noauthOptions).success(function(result) {
				console.log(result);
				if (result.code == 0) {
					if(result.data.versionNum == versionCode ) {
						if(rootScope.onclickCheckUpdate){
							showToast($ionicLoading, "已经是最新版本");
						}
						deferred.resolve(false);
					} else {						
						checkAndDownload(result, isHint).then(function(result) {
							deferred.resolve(result);
						});	
					}
				} else {
					if(rootScope.onclickCheckUpdate){
						showToast($ionicLoading, result.msg);
					}
					deferred.resolve(false);
				}					
			}).error(function(result) {
				deferred.resolve(false);
				if(!angular.isDefined(isHint)) return;
				if(!isHint) return;
				// 显示提示信息
				showAlert('提示', '检测版本失败...');
			});

			return deferred.promise;
		}

		function checkAndDownload(result, isHint) {
			var d = $q.defer();
			//synExecuteCmdDebug({msg: 'checkAndDownload'});
			
			if(ionic.Platform.platform() == 'android') { //android更新本地下载	
				console.log('有版本更新');
				$ionicPopup.show({
					title: '提示',
					cssClass: 'vboss_search_popup',
					template: '<br>有版本更新，请下载更新!<br><br>',
					buttons: [
						{
							text: '取消',
							type: 'button-positive',
							onTap: function(e){
							  d.resolve(false);
							  return true;
							}
						},
						{
							text: '确定',
							type: 'btn-yellow',
							onTap: function(e) {				
								androidUpgrade(result, isHint).then(function(result) {
									deferred.resolve(result);
								}, function(err) {
									deferred.resolve(false);
								});															
							  	return true;
							}
						}
					]
				});
					
			} else if(ionic.Platform.platform() == 'ios') { //ios跳转到appstore
				var versionPopup = $ionicPopup.show({
					title: '提示',
					type: 'button-positive',
					template: '有版本更新，请前往苹果商店下载!',
					buttons: [
						{ text: '取消', type: 'button-positive'},
						{
							text: '<b>确定</b>',
							type: 'btn-yellow',
							onTap: function(e) {
								d.resolve(true);
								$cordovaFileOpener2.openURL(appStroeURL, {
									success:  d.promise
								});
							}
						}]
				});
			}

			return d.promise;
		}


		function androidUpgrade(result, isHint) {
			var d = $q.defer();			
			var targetPath = cordova.file.externalApplicationStorageDirectory + "aibaoapp.apk";
			
			var trustHosts = true;

			rootScope.process = 0;
			
			$ionicLoading.show({
				template: '<ion-spinner icon="bubbles" class="spinner-assertive spinner spinner-bubbles"></ion-spinner><br>正在连接服务器...'
			});
			
			$cordovaFileTransfer.download(ucHost + "/ucenter/VerMgr/download?sysId=" + result.data.id, targetPath, noauthOptions, trustHosts).then(function (result) {
				console.log(result);

				$ionicLoading.hide();

				d.resolve(true);

				// success
				$cordovaFileOpener2.open(targetPath,
					'application/vnd.android.package-archive').then(function () {
				}, function (err) {
					showAlert('提示', '打开文件失败, 文件可能不完整!' + angular.toJson(err));
				});				
				
			}, function (err) {
				// error
				d.resolve(false);
				hideLoading();
				showAlert('提示', '下载文件出错，如果重试仍然出错，请到官网直接下载安装' + angular.toJson(err));
			}, function (progress) {
				if (typeof progress == 'undefined') return;
				showProgress(progress);
			});

			return d.promise;
		}


		function showProgress(progress) {
			// 显示进度条
			var first = true;
			$timeout(function() {
				rootScope.$apply(function() {
					if(progress.lengthComputable) {
						// rootScope.process = (progress.loaded/progress.total) * 100;
						// synExecuteCmdDebug({msg:"下载进度..." + JSON.stringify(progress)});
						// showLoading("已下载文件... " + dProgress + "%");
						if(rootScope.process == 0 && first) {
							first = false;
							$ionicLoading.hide();
							$ionicLoading.show({
								template: '<ion-spinner icon="bubbles" class="spinner-assertive spinner spinner-bubbles"></ion-spinner><br>已经下载：{{process}}%'
							});
						}

						if($('.loading-container').hasClass('visible') == false) {
							$ionicLoading.show({
								template: '<ion-spinner icon="bubbles" class="spinner-assertive spinner spinner-bubbles"></ion-spinner><br>已经下载：{{process}}%'
							});
						}

						var downloadProgress = (progress.loaded / progress.total) * 100;
						rootScope.process = Math.floor(downloadProgress);
						
						if (downloadProgress > 99) {
							$ionicLoading.hide();
						}
					} else {
						synExecuteCmdDebug({msg:"未获取到文件大小..."});
					}
				});
			});
		}

		//双击退出
		$ionicPlatform.registerBackButtonAction(function(e) {
			//判断处于哪个页面时双击退出
			if ($location.path() == '/app/main' || $location.path() == '/login') {
				if ($rootScope.backButtonPressedOnceToExit) {
					navigator.Backbutton.goHome(function() {
						console.log('go home success');
					}, function() {
						console.log('go home fail');
					});
				} else {
					$rootScope.backButtonPressedOnceToExit = true;
					$timeout(function() {
						$rootScope.backButtonPressedOnceToExit = false;
					}, 2000);	
					$cordovaToast.showShortTop('再按一次退出系统');				
				}
			} else if($location.path() == '/about') {
				$rootScope.backButtonPressedOnceToExit = false;
				$state.go("app.main");
				$ionicViewSwitcher.nextDirection("back");
			} else if($ionicHistory.backView()) {
				$rootScope.backButtonPressedOnceToExit = false;
				$ionicHistory.goBack();
				$ionicViewSwitcher.nextDirection("back");
			} else {
				$rootScope.backButtonPressedOnceToExit = false;
				$state.go("app.main");
				$ionicViewSwitcher.nextDirection("back");
			}
			e.preventDefault();
			return false;
		}, 101);
	}]);
