function chzhCtrl($ionicViewSwitcher, $scope, $state, $timeout, $http, $ionicModal, $ionicPopup, $ionicLoading, $ionicHistory, CommomService, $filter, ionicDatePicker, $window) {

	$scope.data = {};
	$scope.totalCount = 0;
	$scope.totalPage = 1;
	$scope.currPage = 1;
	$scope.pageSize = 10;
	$scope.reverseList = [];
	$scope.isShow = false;
	$scope.data.startTime = rootScope.timeParams;
	$scope.data.endTime = rootScope.timeParams;
	$scope.noData = false;

	$scope.seller = loginToken;
	$scope.showSubStores = loginToken.storeType == 2;
	$scope.selStoreId = rootScope.selStoreId;
	$scope.subStoreInfoList = loginToken.subStoreInfoList;

	$scope.cHeight = $scope.showSubStores ? hasSubHeight : defaultHeight;

	$scope.$on("$ionicView.leave", function() {
		if(chzhPopup && chzhPopup != null) chzhPopup.close();
		ionicDatePicker.close();
	});
	/*
	 *返回上一页
	 */
	$scope.goBack = function () {
		$state.go("app.main");
		$ionicViewSwitcher.nextDirection("back");
	};
	// $scope.data.startTime = new Date().format("yyyy-MM-dd");
	// $scope.data.endTime = new Date().format("yyyy-MM-dd");

	$scope.query = function () {
		rootScope.scrollTop("chzhMainScroll");
		$scope.currPage = 1;
		$scope.reverseList = [];
		$scope.loadData();
	}

	$scope.doRefresh = function () {
		$scope.currPage = 1;
		$scope.reverseList = [];
		$scope.loadData();
		$scope.$broadcast('scroll.refreshComplete');
	};

	$scope.selStore = function () {
		rootScope.scrollTop("chzhMainScroll");
		$scope.selStoreId = $("#selStore").val();
		$scope.currPage = 1;
		$scope.reverseList = [];
		$scope.loadData();
	};

	$scope.$on('$ionicView.afterEnter', function() {
		// if($scope.showSubStores)  {
		// 	$("#mainDiv").height($window.innerHeight - 49);
		// } else {
		// 	$("#mainDiv").height($window.innerHeight - 5);
		// }
		$scope.query();
	});

	$scope.loadData = function () {
		var startTime = $scope.data.startTime;
		var endTime = $scope.data.endTime;

		checkLogin().then(function(result) {
			var dataJson = {
				fromDate: startTime,
				toDate: endTime,
				salesmanId: $scope.data.employeeId,
				rechargeType: 'RCA',
				storeId: $scope.selStoreId,
				page: $scope.currPage,
				limit: $scope.pageSize
			};

			showLoading("正在加载数据，请稍后...");
		
			var url = webHost + 'api/vboss/rechargelist';
			$http.post(url,dataJson).success(function(data) {
				$scope.$broadcast('scroll.refreshComplete');
				$scope.$broadcast('scroll.infiniteScrollComplete');
				if (data.records) {
					var g = data.total % $scope.pageSize;
					$scope.totalPage = parseInt(data.total / $scope.pageSize) + (g > 0 ? 1 : 0);
					console.log($scope.totalPage);
					console.log("totalpage==页数=="+data.totalPage+"==总条数=="+data.totalCount);
					console.log("currPage==当前页=="+$scope.currPage);
					for (var i = 0; i < data.records.length; i++) {
						$scope.reverseList.push(data.records[i]);
					}
					$scope.noData = data.records.length < 1;
					console.log($scope.reverseList);
				}
			}).error(function (result) {
				$scope.$broadcast('scroll.refreshComplete');
				$scope.$broadcast('scroll.infiniteScrollComplete');
			});
		});
	};

	$scope.loadMore = function () {
		if ($scope.currPage >= $scope.totalPage) {
			$scope.$broadcast('scroll.infiniteScrollComplete');
			return;
		}
		$scope.currPage += 1;
		$scope.loadData();
		$scope.$broadcast('scroll.infiniteScrollComplete');
	}

	$scope.showQuery = function () {
		checkLogin().then(function(result) {
			CommomService.loadEmployees($scope.selStoreId, 'S');
		});
		$scope.isShow = !$scope.isShow;
		$scope.showChzhPopup();
	}

	var chzhPopup = null;
	$scope.showChzhPopup = function () {
		var employeeId = $scope.data.employeeId;
		var startTime = $scope.data.startTime;
		var endTime = $scope.data.endTime;
		chzhPopup = $ionicPopup.show({
			title: '请选择',
			cssClass: 'vboss_search_popup',
			templateUrl: 'js/chzh/popup_chzh.html',
			scope: $scope,
			buttons: [
				{
					text: '取消',
					type: 'button-cancle',
					onTap: function(e) {
					  $scope.data.employeeId = employeeId;
					  $scope.data.startTime = startTime;
		              $scope.data.endTime = endTime;
					  return true;
					}
				},
				{
					text: '确定',
					type: 'button-ok',
					onTap: function(e) {
					  $scope.query();
					  return true;
					}
				}
			]
		});
		chzhPopup.then(function (res) {
		});
	};

	
	//主体对象
	$scope.datepickerObjectFrom = {
		inputDate: new Date(Date.parse($scope.data.startTime.replace(/-+/g, '/'))),  //可选，输入值		
		callback: function (val) {  //Mandatory
			if (typeof (val) === 'undefined') {
			} else {
				console.log('Selected date is : ', val);
				$scope.datepickerObjectFrom.inputDate = new Date(val);  //这行官网没有，不设置 的话，选中日期不能回填到页面。
				$scope.data.startTime = $filter('date')(val, 'yyyy-MM-dd');
			}
		}
	};

	$scope.showFromDateDialog = function(){  
		$scope.datepickerObjectFrom.inputDate = new Date(Date.parse($scope.data.startTime.replace(/-+/g, '/')));
		ionicDatePicker.openDatePicker($scope.datepickerObjectFrom); 
	};

	//主体对象
	$scope.datepickerObjectTo = {
		inputDate: new Date(Date.parse($scope.data.endTime)),  //可选，输入值		
		callback: function (val) {  //Mandatory
			if (typeof (val) === 'undefined') {
			} else {
				console.log('Selected date is : ', val);
				$scope.datepickerObjectTo.inputDate = new Date(val);  //这行官网没有，不设置 的话，选中日期不能回填到页面。
				$scope.data.endTime = $filter('date')(val, 'yyyy-MM-dd');
			}
		}
	};

	$scope.showToDateDialog = function(){  
		$scope.datepickerObjectTo.inputDate = new Date(Date.parse($scope.data.endTime.replace(/-+/g, '/')));
		ionicDatePicker.openDatePicker($scope.datepickerObjectTo); 
	};

	$ionicModal.fromTemplateUrl('js/chzh/chzhDetail.html', {
		scope: $scope,
		animation: 'slide-in-up'
	}).then(function (modal) {
		$scope.chzhDetailModal = modal;
	});

	$scope.openChzhDetailModal = function (item) {
		$scope.item = item;
		$scope.item.balance = item.rechargeAmt + item.preBalanceAmt;
		console.log($scope.item );
		//$scope.loadSellDetail(item.id);
		$scope.chzhDetailModal.show();
	};

	$scope.closesChzhDetailModal = function () {
		$scope.chzhDetailModal.hide();
	};

	//Cleanup the modal when we're done with it!
	$scope.$on('$destroy', function () {
		$scope.chzhDetailModal.remove();
	});

	$(document).ready(function () {
		$("#showList").click(function () {
			$("#detailList").slideToggle("fast");
		});
	});


}
