angular.module('starter.controllers', ['ionic-datepicker','ionic-monthpicker'])
.config(function (ionicDatePickerProvider) {

	//方便的年月日设置方式，正和我意，可以随便改了。
	var weekDaysList = ["日", "一", "二", "三", "四", "五", "六"];
	//默认值：["S", "M", "T", "W", "T", "F", "S"];
	
	var monthList = ["一月", "二月", "三月", "四月", "五月", "六月", "七月", "八月", "九月", "十月", "十一月", "十二月"];
	//默认值：["January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December"];

    var datePickerObj = {
		titleLabel: '选择日期',  //可选
		setLabel: '确定',  //可选
		todayLabel: '今天',  //可选
		closeLabel: '关闭',  //可选
		inputDate: new Date(),  //可选，输入值
		to: new Date(),
		mondayFirst: true,  //可选,星期一开头
		weeksList: weekDaysList, //可选
		monthsList: monthList, //可选
		templateType: 'popup', //可选i.e.的模式 modal or popup(兼容模式？)
		showTodayButton: true, //可选
		//modalHeaderColor: 'bg-color light', //可选
		//modalFooterColor: 'bg-color light', //可选
		dateFormat: 'yyyy-MM-dd', //可选
		closeOnSelect: true //可选,设置选择日期后是否要关掉界面。原本是false。
    };
	ionicDatePickerProvider.configDatePicker(datePickerObj);	
 }).filter('arrayValue',function() {
	return function(arrs, idx, key){
		if(arrs && arrs.length > idx) {
			return arrs[idx][key];
		} else {
			return '';
		}
	}
 }).filter('zeroSpace',function() {
	return function(input){
		if(input == 0) {
			return "";
		} else {
			return input;
		}
	}
 })
 .filter('dateStr',function(){
	return function(input, formatStr){
		if(input) {
			return new Date(Date.parse(input.replace(/-+/g,"/"))).format(formatStr);
		} else {
			return '';
		}
	} 
 }).filter('salesStatus',function(){
	return function(input){
		for(var i=0;i<salesStatuses.length;i++) {
			if(salesStatuses[i].id == input) {
				return salesStatuses[i].name;
			}
		}
		return '';
	}
 }).filter('tradeType',function(){
	return function(input){
		for(var i=0;i<tradeTypes.length;i++) {
			if(tradeTypes[i].id == input) {
				return tradeTypes[i].name;
			}
		}
		return '';
	}
 }).filter('salesType',function(){
	return function(input) {  
		for(var i=0;i<salesTypes.length;i++) {
			if(salesTypes[i].id == input) {
				return salesTypes[i].name;
			}
		}
		for(var i=0;i<rechargeTypes.length;i++) {
			if(rechargeTypes[i].id == input) {
				return rechargeTypes[i].name;
			}
		}
		return '';
	}
 })
 .controller('AppCtrl', ["$scope", "$state", "$ionicModal", "$timeout", "$ionicPopup", "$ionicSideMenuDelegate", function($scope, $state, $ionicModal, $timeout, $ionicPopup, $ionicSideMenuDelegate) {

	// With the new view caching in Ionic, Controllers are only called
	// when they are recreated or on app start, instead of every page change.
	// To listen for when this page is active (for example, to refresh data),
	// listen for the $ionicView.enter event:
	//$scope.$on('$ionicView.enter', function(e) {
	//});

	// Form data for the login modal
	$scope.loginData = {};

	// Open the login modal
	$scope.logoutSystem = function() {
		$ionicPopup.show({
			title: '提示',
			cssClass: 'vboss_search_popup',
			template: '<br>您确定要注销登录吗？<br><br>',
			buttons: [
				{
					text: '取消',
					type: 'button-positive',
					onTap: function(e){
					  return true;
					}
				},
				{
					text: '确定',
					type: 'btn-yellow',
					onTap: function(e) {
						//$ionicSideMenuDelegate.toggleLeft(false);
						returnLogin();										
						return true;
					}
				}
			]
		});		
	};

	$scope.onclickCheckUpdate = function () {
		rootScope.checkUpdate();
		rootScope.onclickCheckUpdate = true;
	};

	$scope.$on("$ionicView.leave", function() {
		//console.log("parent - leave");
	});

	if(ionic.Platform.platform() == 'ios') {
		$scope.isShowUpdate = false;
	}else{
		$scope.isShowUpdate = true;
	}
}])
  .controller('HandoverCtrl', ["$ionicViewSwitcher", "$scope", "$state", "$timeout", "$http", "$ionicModal", "$ionicPopup","$ionicLoading", "$ionicHistory", "CommomService","$rootScope","$filter", "ionicDatePicker","$window",handoverCtrl])
  .controller('XsdjCtrl', ["$ionicViewSwitcher", "$scope", "$state", "$timeout", "$http", "$ionicModal", "$ionicLoading", "$ionicPopup", "$ionicHistory", "CommomService", "$filter", "ionicDatePicker","$window",xsdjCtrl])
  .controller('QsfxCtrl', ["$ionicViewSwitcher", "$scope", "$state", "$timeout", "$http", "$ionicModal", "$ionicLoading", "$ionicPopup", "$ionicHistory", "$filter", qsfxCtrl])
  .controller('RjbbCtrl', ["$ionicViewSwitcher", "$scope", "$state", "$timeout", "$http", "$ionicModal", "$ionicLoading", "$ionicHistory","$filter","CommomService", "ionicDatePicker", rjbbCtrl])
  .controller('ChzhCtrl', ["$ionicViewSwitcher", "$scope", "$state", "$timeout", "$http", "$ionicModal", "$ionicPopup", "$ionicLoading", "$ionicHistory", "CommomService", "$filter", "ionicDatePicker", "$window",chzhCtrl])
  .controller('MsgsCtrl', ["$ionicViewSwitcher", "$scope", "$state", "$timeout", "$http", "$ionicModal", "$ionicPopup", "$ionicLoading", "$ionicHistory", "CommomService", "$filter", "ionicDatePicker","$window", msgsCtrl])
  .controller('SpxsCtrl', ["$ionicViewSwitcher", "$scope", "$state", "$timeout", "$http", "$ionicPopup", "$ionicModal", "$ionicLoading", "$ionicHistory", "CommomService", "$filter", "ionicDatePicker","$window",spxsCtrl])
  .controller('YyhzCtrl', ["$ionicViewSwitcher", "$scope", "$state", "$timeout", "$http", "$ionicLoading", "CommomService", "$ionicHistory", "$filter", "$ionicScrollDelegate", "ionicDatePicker","MonthPicker", yyhzCtrl])
  .controller('MainCtrl', ["$ionicViewSwitcher", "$scope", "$state", "$timeout", "$http", "$ionicModal", "$ionicLoading", "CommomService", "$filter", "ionicDatePicker", mainCtrl])
  .controller('LoginCtrl', ["$ionicViewSwitcher", "$scope", "$state", "$timeout", "$http", "$ionicModal", "$ionicLoading", "$cordovaKeyboard", loginCtrl])
  .controller('AboutCtrl',["$ionicViewSwitcher", "$scope", "$state", "$timeout", "$http", "$ionicLoading", "CommomService", "$ionicHistory", "$filter", "$ionicScrollDelegate", "ionicDatePicker","MonthPicker", aboutCtrl])
  .controller('AcctCtrl', ["$ionicViewSwitcher", "$scope", "$state", "$timeout", "$http", "$ionicModal", "$ionicPopup", "$ionicLoading", "$ionicHistory", "CommomService", "$filter", "ionicDatePicker", acctCtrl])
  .controller('LogsCtrl', ["$ionicViewSwitcher", "$scope", "$state", "$timeout", "$http", "$ionicModal", "$ionicPopup", "$ionicLoading", "$ionicHistory", "CommomService", "$filter", "ionicDatePicker", "$window", logsCtrl]);  
