function handoverCtrl($ionicViewSwitcher, $scope, $state, $timeout, $http, $ionicModal, $ionicPopup, $ionicLoading, $ionicHistory, CommomService, $rootScope, $filter, ionicDatePicker,$window) {

	$scope.data = {};
	$scope.totalCount = 0;
	$scope.totalPage = 1;
	$scope.currPage = 1;
	$scope.pageSize = 10;
	$scope.handoverList = [];
	$scope.payList = [];
	$scope.amtList = [];
	$scope.returnList = [];
	$scope.voidList = [];	
	$scope.data.startTime = rootScope.timeParams;
	$scope.data.endTime = rootScope.timeParams;
	$scope.noData = false;

	$scope.seller = loginToken;
	$scope.showSubStores = loginToken.storeType == 2;
	$scope.selStoreId = rootScope.selStoreId;
	$scope.subStoreInfoList = loginToken.subStoreInfoList;

	$scope.cHeight = $scope.showSubStores ? hasSubHeight : defaultHeight;

	$scope.$on("$ionicView.leave", function() {
		if(handoverPopup && handoverPopup != null) handoverPopup.close();
		ionicDatePicker.close();
	});
	/*
	 *返回上一页
	 */
	$scope.goBack = function () {
		$state.go("app.main");
		$ionicViewSwitcher.nextDirection("back");
	};
		
	$scope.loadData = function () {
		var startTime = $scope.data.startTime;
		var endTime = $scope.data.endTime;

		//console.log('loadData----'+startTime + '-----'+endTime);
		checkLogin().then(function(result) {

			var dataJson = {
				fromDate: startTime,
				toDate: endTime,
				storeId: $scope.selStoreId,
				staffId: $scope.data.employeeId,
				status: '1',
				page: $scope.currPage,
				limit: $scope.pageSize,
				orderByField: 'CreatedTime',
			};
			showLoading("正在加载数据，请稍后...");
			var url = webHost + 'api/vboss/handoverlist';
			$http.post(url,dataJson).success(function(data) {
				$scope.$broadcast('scroll.refreshComplete');
				$scope.$broadcast('scroll.infiniteScrollComplete');
				if (data.records) {
					console.log(data);
					var g = data.total % $scope.pageSize;
					$scope.totalPage = parseInt(data.total / $scope.pageSize) + (g > 0 ? 1 : 0);
					for (var i = 0; i < data.records.length; i++) {
						$scope.handoverList.push(data.records[i]);
					}
					$scope.noData = data.records.length < 1;
				}
			}).error(function (data) {
				$scope.$broadcast('scroll.refreshComplete');
				$scope.$broadcast('scroll.infiniteScrollComplete');
			});
		});
	};

	$scope.query = function () {
		rootScope.scrollTop("handMainScroll");
		$scope.currPage = 1;
		$scope.handoverList = [];
		$scope.loadData();
	};

	$scope.doRefresh = function () {
		$scope.currPage = 1;
		$scope.handoverList = [];
		$scope.loadData();
		$scope.$broadcast('scroll.refreshComplete');
	};

	$scope.selStore = function () {
		rootScope.scrollTop("handMainScroll");
		$scope.selStoreId = $("#selStore").val();
		$scope.currPage = 1;
		$scope.handoverList = [];
		$scope.loadData();
	};

	$scope.$on('$ionicView.afterEnter', function() {    
		// if($scope.showSubStores)  {
		// 	$("#mainDiv").height($window.innerHeight - 88);
		// } else {
		// 	$("#mainDiv").height($window.innerHeight - 44);
		// }
		$scope.query();
	});

	$scope.loadHandoverDetail = function (handoverId) {
		checkLogin().then(function(result) {
			showLoading("正在加载数据，请稍后...");
			var url = webHost + 'api/vboss/handoverdetail/' + handoverId;
			$http.get(url).success(function(data) { 		
				if (data.code == 0) {
					var payList = [];
					var amtList = [];
					var returnList = [];
					var voidList = [];
					for(var i = 0; i < data.data.length; i++) {
						if(data.data[i].salesType == 'R') {
							returnList.push(data.data[i]);
						} else if(data.data[i].salesType == 'RCA') {	
							amtList.push(data.data[i]);
						} else if(data.data[i].salesType == 'S') {
							payList.push(data.data[i]);
						} else if(data.data[i].salesType == 'V') {
							voidList.push(data.data[i]);
						}
					}
					$scope.sellDetailList = data.data;
					$scope.payList = payList;
					$scope.amtList = amtList;
					$scope.returnList = returnList;
					$scope.voidList = voidList;
				}
			});
		});

	}

	$scope.loadMore = function () {
		if ($scope.currPage >= $scope.totalPage) {
			$scope.$broadcast('scroll.infiniteScrollComplete');
			return;
		}
		$scope.currPage += 1;
		$scope.loadData();
		$scope.$broadcast('scroll.infiniteScrollComplete');
	};

	$scope.showQuery = function () {
		checkLogin().then(function(result) {
			CommomService.loadEmployees($scope.selStoreId, 'C');
		});
		$scope.isShow = !$scope.isShow;
		$scope.showHandoverPopup();
	}

	var handoverPopup = null;
	$scope.showHandoverPopup = function () {
		var employeeId = $scope.data.employeeId;
		var startTime = $scope.data.startTime;
		var endTime = $scope.data.endTime;
		handoverPopup = $ionicPopup.show({
			title: '请选择',
			cssClass: 'vboss_search_popup',
			templateUrl: 'js/handover/popup_handover.html',
			scope: $scope,
			buttons: [
				{
					text: '取消',
					type: 'button-cancle',
					onTap: function(e){
					  $scope.data.employeeId = employeeId;
					  $scope.data.startTime = startTime;
		              $scope.data.endTime = endTime;
					  return true;
					}
				},
				{
					text: '确定',
					type: 'button-ok',
					onTap: function(e) {
					  $scope.query();
					  return true;
					}
				}
			]
		});
		handoverPopup.then(function (res) {
		});
	};
	
	$ionicModal.fromTemplateUrl('js/handover/handoverDetail.html', {
		scope: $scope,
		animation: 'slide-in-up'
	}).then(function (modal) {
		$scope.handoverDetailModal = modal;
	});

	$scope.openhandoverDetailModal = function (item) {
		$scope.item = item;
		$scope.item.totalAmt = item.ttlsalesAmt + item.ttlreturntAmt + item.ttlvoidAmt;
		console.log($scope.item);
		$scope.loadHandoverDetail(item.id);
		$scope.handoverDetailModal.show();
		$scope.showHdetail(1);
	};

	$scope.closeshandoverDetailModal = function () {
		$scope.handoverDetailModal.hide();
	};
	
	//Cleanup the modal when we're done with it!
	$scope.$on('$destroy', function () {
		$scope.handoverDetailModal.remove();
	});

	$scope.oldIndex = 0;
	$scope.hDetail1 = true;
	$scope.showHdetail = function (index) {
		showLoading("正在加载数据，请稍后...");
		if (index == 1) {
			if ($scope.oldIndex == index) {
				$scope.hDetail1 = true;
			} else {
				$scope.hDetail1 = true;
			}
			$scope.hDetail2 = false;
			$scope.hDetail3 = false;
			$scope.hDetail4 = false;

			$("#sales").addClass("selTab").removeClass("noSelTab");
			$("#recharge").removeClass("selTab").addClass("noSelTab");
			$("#void").removeClass("selTab").addClass("noSelTab");
			$("#return").removeClass("selTab").addClass("noSelTab");

		} else if (index == 2) {
			if ($scope.oldIndex == index) {
				$scope.hDetail2 = true;
			} else {
				$scope.hDetail2 = true;
			}
			$scope.hDetail1 = false;
			$scope.hDetail3 = false;
			$scope.hDetail4 = false;

			$("#sales").removeClass("selTab").addClass("noSelTab");
			$("#recharge").addClass("selTab").removeClass("noSelTab");
			$("#void").removeClass("selTab").addClass("noSelTab");
			$("#return").removeClass("selTab").addClass("noSelTab");
		} else if (index == 3) {
			if ($scope.oldIndex == index) {
				$scope.hDetail3 = true;
			} else {
				$scope.hDetail3 = true;
			}
			$scope.hDetail1 = false;
			$scope.hDetail2 = false;
			$scope.hDetail4 = false;

			$("#sales").removeClass("selTab").addClass("noSelTab");
			$("#recharge").removeClass("selTab").addClass("noSelTab");
			$("#void").addClass("selTab").removeClass("noSelTab");
			$("#return").removeClass("selTab").addClass("noSelTab");
		} else if (index == 4) {
			if ($scope.oldIndex == index) {
				$scope.hDetail4 = true;
			} else {
				$scope.hDetail4 = true;
			}
			$scope.hDetail1 = false;
			$scope.hDetail2 = false;
			$scope.hDetail3 = false;

			$("#sales").removeClass("selTab").addClass("noSelTab");
			$("#recharge").removeClass("selTab").addClass("noSelTab");
			$("#void").removeClass("selTab").addClass("noSelTab");
			$("#return").addClass("selTab").removeClass("noSelTab");
		}		
		$timeout(function () {
			hideLoading();
		}, 500);
	}

	//主体对象
	$scope.datepickerObjectFrom = {
		inputDate: new Date(Date.parse($scope.data.startTime.replace(/-+/g, '/'))),  //可选，输入值		
		callback: function (val) {  //Mandatory
			if (typeof (val) === 'undefined') {
			} else {
				console.log('Selected date is : ', val);
				$scope.datepickerObjectFrom.inputDate = new Date(val);  //这行官网没有，不设置 的话，选中日期不能回填到页面。
				$scope.data.startTime = $filter('date')(val, 'yyyy-MM-dd');
			}
		}
	};

	$scope.showFromDateDialog = function(){  
		ionicDatePicker.openDatePicker($scope.datepickerObjectFrom); 
	};

	//主体对象
	$scope.datepickerObjectTo = {
		inputDate: new Date(Date.parse($scope.data.endTime.replace(/-+/g, '/'))),  //可选，输入值		
		callback: function (val) {  //Mandatory
			if (typeof (val) === 'undefined') {
			} else {
				console.log('Selected date is : ', val);
				$scope.datepickerObjectTo.inputDate = new Date(val);  //这行官网没有，不设置 的话，选中日期不能回填到页面。
				$scope.data.endTime = $filter('date')(val, 'yyyy-MM-dd');
			}
		}
	};

	$scope.showToDateDialog = function(){  
		ionicDatePicker.openDatePicker($scope.datepickerObjectTo); 
	};
}