function loginCtrl($ionicViewSwitcher, $scope, $state, $timeout, $http, $ionicModal, $ionicLoading, $cordovaKeyboard, $invalid) {

	if(loginToken.accessToken) {
		$state.go("app.main");
		return;
	}

	$scope.$on("$ionicView.afterEnter", function() {
		$timeout(function() {
			if(handler.navigator && handler.navigator.splashscreen && handler.navigator.splashscreen.hide) {	
				handler.navigator.splashscreen.hide();
			}
		}, 1000);
	});

	$scope.data = {};
	$scope.data.oldPassword = seller.password;
	$scope.data.username = seller.userName;
	$scope.data.password = seller.password;

	$scope.login = function () {
		if (window && !window.cordova) { // windows(win32)/MACOS desktop
			$scope.loginMain();
			return;
		}
		//关闭手机键盘
		if ($cordovaKeyboard.isVisible())
			$cordovaKeyboard.close();
		$timeout(function () {
			$scope.loginMain();
		}, 100);
	};

	$scope.loginMain = function () {

		var userName = $scope.data.username;
		var pwd = $scope.data.password;
		if (!userName || userName == '') {
			showToast($ionicLoading, "请输入账号");
			return;
		}
		if (!pwd || pwd == '') {
			showToast($ionicLoading, "请输入密码");
			return;
		}

		if (userName.indexOf(":") > -1) {
			showToast($ionicLoading, "账号不存在，请重新输入");
			return;
		}

		showLoading("正在登录，请稍后...");

		seller.userName = userName;
		seller.password = hex_md5(pwd),

		login().then(function(result) {
			resetRootData();  // 重设数据
			rootScope.selStoreId = loginToken.storeId;
			rootScope.selStoreName = loginToken.storeName;
			rootScope.selStoreType = loginToken.storeType;
			$state.go("app.main");			
		},function(result) {
			if(result == 1) {
				showToast(handler.ionicLoading, '您不是付费账号，请付费激活!');
			} else if(result == 2) {
				showToast(handler.ionicLoading, '您的账号已过期，请续费激活!');
			}
		});	
	}

}


