function mainCtrl($ionicViewSwitcher, $scope, $state, $timeout, $http, $ionicModal, $ionicLoading,
		CommomService, $filter, ionicDatePicker) {

	$scope.$on("$ionicView.leave", function() {
		ionicDatePicker.close();
	});

	$scope.$on("$ionicView.afterEnter", function() {
		$timeout(function() {
			if(handler.navigator && handler.navigator.splashscreen && handler.navigator.splashscreen.hide) {	
				handler.navigator.splashscreen.hide();
			}
		}, 1000);
	});
	
	$scope.doRefresh = function() {
		getData();
		$scope.$broadcast('scroll.refreshComplete');
	};

	$scope.currentDate = rootScope && rootScope.timeParams ? rootScope.timeParams : new Date().format('yyyy-MM-dd');

	function getData() {

		checkLogin().then(function(result) {
			var jsonData = {
				storeId: rootScope.selStoreId,
				dateStr: rootScope.timeParams,
				model: 0
			};
			
			var url = webHost + 'api/vboss/dailysales';

			$http.post(url, jsonData, {}).success(function(data) {
				console.log(data);
				if (data.code == 0) {
					// console.log('init---' + angular.toJson(result));
					var dateStr = new Date().format("yyyyMMddhh");
					addDataCache('mainData', dateStr, data.data);
	
					$scope.totalAmt = data.data.salesCount.salesAmt + data.data.returnCount.salesAmt + data.data.voidCount.salesAmt;
					$scope.gainAmt = data.data.salesCount.gainAmt + data.data.returnCount.gainAmt + data.data.voidCount.gainAmt;
					$scope.salesNum = data.data.salesCount.salesNum + data.data.returnCount.salesNum + data.data.voidCount.salesNum;
					$scope.voidAmt = data.data.voidCount.salesAmt;
					$scope.rechargeAmt = data.data.rechargeCount.rechargeAmt;						
					$scope.returnAmt = data.data.returnCount.salesAmt;
					$scope.msgNum = data.data.msgNum;
				}
			});
		});
	};
	
	$scope.$on("bc-login", function() {
		// $scope.time = seller.lastestlogtime;
		// getData();
	});

	$scope.$on('$ionicView.afterEnter', function() {            
		var dateStr = new Date().format("yyyyMMddhh");
		var cacheData = getDateCache('mainData', dateStr);
		if(cacheData) {			
			$scope.totalAmt = cacheData.salesCount.salesAmt + cacheData.returnCount.salesAmt + cacheData.voidCount.salesAmt;
			$scope.gainAmt = cacheData.salesCount.gainAmt + cacheData.returnCount.gainAmt + cacheData.voidCount.gainAmt;
			$scope.salesNum = cacheData.salesCount.salesNum + cacheData.returnCount.salesNum + cacheData.voidCount.salesNum;
			$scope.voidAmt = cacheData.voidCount.salesAmt;
			$scope.rechargeAmt = cacheData.rechargeCount.rechargeAmt;						
			$scope.returnAmt = cacheData.returnCount.salesAmt;		
			$scope.msgNum = cacheData.msgNum;

		} else {
		  getData();
		}
	});

	$scope.viewTitle =  rootScope && rootScope.selStoreName ? rootScope.selStoreName : '首页';
	$scope.seller = loginToken;
	$scope.subStoreInfoList = loginToken.subStoreInfoList;
	$scope.showSubStores = loginToken.storeType == 2;	

	$scope.msgNum = 0;
	$scope.date = new Date().format("yyyy-MM-dd");
	$scope.week = new Date().getDay();

	var dd = function() {
		if ($scope.week == 0) {
			return "日";
		} else if ($scope.week == 1) {
			return "一";
		} else if ($scope.week == 2) {
			return "二";
		} else if ($scope.week == 3) {
			return "三";
		} else if ($scope.week == 4) {
			return "四";
		} else if ($scope.week == 5) {
			return "五";
		} else if ($scope.week == 6) {
			return "六";
		}
	};
	
	$scope.day = $scope.date + " 星期" + dd();

	$scope.preDay = function() {
		var before = $scope.currentDate;
		before = getYestoday(before);
		$scope.currentDate = before;
		rootScope.timeParams = $scope.currentDate;
		$scope.datepickerObjectEnd.inputDate = new Date(Date.parse($scope.currentDate.replace(/-+/g, '/'))); 
		//options.date = new Date(Date.parse($scope.currentDate.replace(/-+/g, '/'))); 
		console.log(rootScope.timeParams);
		getData();
		$("#left-bt").css({
			"font-size" : "28px"
		});
		$("#right-bt").css({
			"font-size" : "22px"
		});
	};

	$scope.nextDay = function() {
		var aa = new Date().format('yyyy-MM-dd')
		var later = $scope.currentDate;
		later = getNextday(later);
		if (later > aa) {
			showToast($ionicLoading,'此日期不能选择!');
		} else {
			$scope.currentDate = later;
			rootScope.timeParams = $scope.currentDate;
			$scope.datepickerObjectEnd.inputDate = new Date(Date.parse($scope.currentDate.replace(/-+/g, '/'))); 
			//options.date = new Date(Date.parse($scope.currentDate.replace(/-+/g, '/'))); 
			getData();
		}
		$("#left-bt").css({
			"font-size" : "22px"
		});
		$("#right-bt").css({
			"font-size" : "28px"
		});
	};
		
	$ionicModal.fromTemplateUrl('js/main/subStores.html', {
		scope: $scope,
		animation: 'slide-in-up'
	}).then(function (modal) {
		$scope.subStoresModal = modal;
	});

	$scope.openSubStoresModal = function () {
		$scope.subStoresModal.show();
	};

	$scope.closeSubStoresModal = function () {
		$scope.subStoresModal.hide();
	};

	$scope.selStoresModal = function (item) {
		if(rootScope.selStoreId != item.id) {
			rootScope.selStoreId = item.id;
			rootScope.selStoreName = item.storeName;
			rootScope.selStoreType = item.storeType;
			$scope.viewTitle = rootScope.selStoreName;
			getData();
		}
		$scope.subStoresModal.hide();
	};

	$scope.noSelStoresModal = function () {
		if(rootScope.selStoreId != seller.storeId) {
		  rootScope.selStoreId = loginToken.storeId;
		  rootScope.selStoreName = loginToken.storeName;
		  rootScope.selStoreType = loginToken.storeType;
		  $scope.viewTitle = rootScope.selStoreName;
		  getData();
		}
		$scope.subStoresModal.hide();
	};

	//Cleanup the modal when we're done with it!
	$scope.$on('$destroy', function () {
		$scope.subStoresModal.remove();
	});
	
	//主体对象
    $scope.datepickerObjectEnd = {
		inputDate: new Date(),  //可选，输入值		
		callback: function (val) {  //Mandatory
			if (typeof (val) === 'undefined') {
			} else {
				console.log('Selected date is : ', val);
				$scope.datepickerObjectEnd.inputDate = new Date(val);  //这行官网没有，不设置 的话，选中日期不能回填到页面。
				$scope.currentDate = $filter('date')(val, 'yyyy-MM-dd');
				rootScope.timeParams = $scope.currentDate;
				getData();
			}
		}
	};

	$scope.showDateDialog = function() {
		$scope.datepickerObjectEnd.inputDate = new Date(Date.parse($scope.currentDate.replace(/-+/g, '/')));
		ionicDatePicker.openDatePicker($scope.datepickerObjectEnd); 
	};
	

	// var options = {
	// 	date: new Date(),
	// 	mode: 'date', 
	// 	minDate: new Date() - 10000,
	// 	allowOldDates: true,
	// 	allowFutureDates: false,
	// 	doneButtonLabel: 'DONE',
	// 	doneButtonColor: '#F2F3F4',
	// 	cancelButtonLabel: 'CANCEL',
	// 	cancelButtonColor: '#000000',
	// 	androidTheme: 1
	//   };

	// $scope.showDateDialog = function() {
	// 	options.date = new Date(Date.parse($scope.currentDate.replace(/-+/g, '/')));
	// 	$cordovaDatePicker.show(options).then(function(date){
	// 		console.log('Selected date is : ', date);
	// 		options.date = new Date(date);
	// 		//$scope.datepickerObjectEnd.inputDate = new Date(date);  //这行官网没有，不设置 的话，选中日期不能回填到页面。
	// 		$scope.currentDate = $filter('date')(date, 'yyyy-MM-dd');
	// 		rootScope.timeParams = $scope.currentDate;
	// 		getData();
	// 	});

	// };

	$scope.showT = function() {
		$ionicLoading.show({
			template: '<ion-spinner icon="bubbles" class="spinner-assertive spinner spinner-bubbles"></ion-spinner><br>正在连接服务器...'
		});
		$timeout(function () {
			$scope.seller.lastestlogtime = $('.loading-container').hasClass('visible');
		},3000);
	};
}
