function qsfxCtrl($ionicViewSwitcher, $scope, $state, $timeout, $http, $ionicModal, $ionicLoading, $ionicPopup, $ionicHistory, $filter) {

	$scope.goBack = function () {
		$state.go("app.main");
		$ionicViewSwitcher.nextDirection("back");
	};

	$scope.startTime = rootScope.timeParams;
	$scope.noData = false;

	$scope.seller = loginToken;
	$scope.showSubStores = loginToken.storeType == 2;
	$scope.selStoreId = rootScope.selStoreId;
	$scope.subStoreInfoList = loginToken.subStoreInfoList;

	$scope.cHeight = $scope.showSubStores ? hasSubHeight + 342: defaultHeight + 342;

	$scope.data = {
		charType: 1,
		dateType: 1,
		sellAmountFlag: true,
		gainAmountFlag: false,
		barChart: false,
		lineChart: true,
		sellNumFlag: false,
		startTime: getLastDate(10),
		endTime: new Date().format("yyyy-MM-dd")
	};

	$scope.selectChartType = function (index) {
		if (index == 1) {
			$scope.data.barChart = false;
			$scope.data.lineChart = true;
		} else {
			$scope.data.barChart = true;
			$scope.data.lineChart = false;
		}
	}

	$scope.loadData = function () {
		$scope.change(1);
	}

	$scope.doRefresh = function () {
		$timeout(function () {	
			$scope.go();
			$scope.$broadcast('scroll.refreshComplete');
		}, 300);
	};

	$scope.selStore = function () {
		rootScope.scrollTop("qsMainScroll");
		$scope.selStoreId = $("#selStore").val();
		$scope.go();
	};

	$timeout(function () {
		$scope.change(1);
	}, 200);

	var type = "1";
	$scope.change = function (obj) {
		rootScope.scrollTop("qsMainScroll");
		if (obj == 1) {
			type = "1";
			$scope.startTime = rootScope.timeParams;
			$scope.go();
			document.getElementById("qs-title").innerHTML = "七日销售数据";
			$("#day").css({"background-color": "#387ef5", "color": "#ffffff"});
			$("#month").css({"background-color": "#FFFFFF", "color": "#007fdb", "border": "1px solid #007fdb"});
		} else {
			type = "0";
			$scope.startTime = rootScope.timeParams;
			$scope.go();
			document.getElementById("qs-title").innerHTML = "十二月销售数据";
			$("#day").css({"background-color": "#FFFFFF", "color": "#007fdb", "border": "1px solid #007fdb"});
			$("#month").css({"background-color": "#387ef5", "color": "#ffffff"});
		}
	}
	$scope.go = function () {

		checkLogin().then(function(result) {
			var chart = echarts.init(document.getElementById('main'));
			var categories = [];
			var sellvalues = [];
			var gainvalues = [];
			var numvalues = [];

			var jsonData = {};

			var url = webHost;
			if(type == '1') {
				url += 'api/vboss/dailysalestrend';
				jsonData = {
					storeId: $scope.selStoreId,
					days: 8
				};
			} else {
				url += 'api/vboss/monthlysalestrend';
				jsonData = {
					storeId: $scope.selStoreId,
					months: 12
				};
			}
			showLoading("正在加载数据，请稍后...");
			
			$http.post(url, jsonData).success(function(data) {
				console.log(data);
				$scope.$broadcast('scroll.refreshComplete');
				$scope.$broadcast('scroll.infiniteScrollComplete');
				if (data.code == 0) {
					$scope.items = [];
					var costAmount = 0.0;
					var gainAmount = 0.0;
					var sellNum = 0;
					var countSell = 0;
					var sellAmount = 0.0;
					for (var i = 0; i < data.data.length; i++) {
						$scope.items.push(data.data[i]);
						costAmount = costAmount + data.data[i].costAmt;
						gainAmount = gainAmount + data.data[i].gainAmt;
						sellNum = sellNum + data.data[i].salesNum;
						countSell = countSell + data.data[i].goodsNum;
						sellAmount = sellAmount + data.data[i].salesAmt;

						sellvalues.push(data.data[i].salesAmt);
						gainvalues.push(data.data[i].gainAmt);
						numvalues.push(data.data[i].salesNum);
						categories.push(data.data[i].salesDate.substring(5,10));
					}
					$scope.costAmount = costAmount;
					$scope.gainAmount = gainAmount;
					$scope.sellNum = sellNum;
					$scope.countSell = countSell;
					$scope.sellAmount = sellAmount;
					var option = {
						tooltip: {
							tigger: 'axis'
						},
						legend: {
							data: ['销售总额', '利润', '商品总数']
						},
						grid: {
							x: '50'
						},
						toolbox: {
							y: 'bottom',
							show: true,
							itemSize: '25',
							feature: {
								//  dataView : {show: true, readOnly: false},
								magicType: {show: true, type: ['line', 'bar']},
								// restore : {show: true},
								// saveAsImage : {show: true}
							}
						},
						calculable: true,
						xAxis: [
							{
								type: 'category',
								boundaryGap: false,
								data: categories		
							}
						],
						yAxis: [
							{
								type: 'value',
								splitArea : {show : true}
							}
						], series: [
							{
								"name": "销售总额",
								"type": "line",
								"data": sellvalues,
								markPoint: {
									data: [
										{type: 'max', name: '最大值'},
										{type: 'min', name: '最小值'}
									]
								}

							},
							{
								"name": "利润",
								"type": "line",
								"data": gainvalues,
								markPoint: {
									data: [
										{type: 'max', name: '最大值'},
										{type: 'min', name: '最小值'}
									]
								}

							},
							{
								"name": "商品总数",
								"type": "line",
								"data": numvalues,
								markPoint: {
									data: [
										{type: 'max', name: '最大值'},
										{type: 'min', name: '最小值'}
									]
								}

							}
						]
					};
					chart.setOption(option);
				}
			}).error(function (data) {
				$scope.$broadcast('scroll.refreshComplete');
				$scope.$broadcast('scroll.infiniteScrollComplete');
			});
		});
	};
	$scope.sh = true;
	$scope.showData = false;
	$scope.showDetail = function () {
		$scope.sh = false;
		$scope.showData = true;
	}
	$scope.hideDetail = function () {
		$scope.sh = true;
		$scope.showData = false;
	}
}
