angular.module('starter.services', []).factory('CommomService', ["$http","$ionicLoading", function($http, $ionicLoading) {
	var self = this;
	self.startTime=null;
	return {
		loadEmployees : function(storeId, staffType) {
			var dateStr = new Date().format("yyyyMMddhh");
			var key = "employees-" + storeId + "-" + staffType;
			var employees = getDateCache(key, dateStr);
			
			if(employees) {
				rootScope.employeeList = employees;
				return;
			}

			var url = webHost + 'api/posStaff/storestaff/'+ storeId + '/' + staffType;
			$http.get(url).success(function(data) {
				console.log(data);
				if (data.code == 0) {
					addDataCache(key, dateStr, data.data);
					rootScope.employeeList = data.data;		
				}
			});

		},
		loadCommodityTypes : function(storeId) {
			var dateStr = new Date().format("yyyyMMddhh");
			var key = "commodityType-" + storeId;
			var commodityTypes = getDateCache(key, dateStr);
			
			if(commodityTypes) {
				rootScope.commodityTypeList = commodityTypes;
				return;
			}

			var jsonData = {
				 'storeId': storeId
			};

			var url = webHost + 'api/posCategory/queryByStoreId';
			$http.post(url, jsonData).success(function(data) {
				console.log(data);
				if (data.code == 0) {
					addDataCache(key, dateStr, data.data);
					rootScope.commodityTypeList = data.data;
				}
			});
		}
	}
}]);
