function spxsCtrl($ionicViewSwitcher, $scope, $state, $timeout, $http, $ionicPopup, $ionicModal, $ionicLoading, $ionicHistory, CommomService, $filter, ionicDatePicker,$window) {

	$scope.data = {};
	$scope.totalCount = 0;
	$scope.totalPage = 1;
	$scope.currPage = 1;
	$scope.pageSize = 10;
	$scope.commoditySellList = [];
	$scope.noData = false;

	$scope.seller = loginToken;
	$scope.showSubStores = loginToken.storeType == 2;
	$scope.selStoreId = rootScope.selStoreId;
	$scope.subStoreInfoList = loginToken.subStoreInfoList;
	$scope.data.startTime = rootScope.timeParams;
	$scope.data.endTime = rootScope.timeParams;

	$scope.cHeight = $scope.showSubStores ? hasSubHeight : defaultHeight;

	$scope.$on("$ionicView.leave", function() {
		if(spxsPopup && spxsPopup != null) spxsPopup.close();
		ionicDatePicker.close();
	});
	/*
	 *返回上一页
	 */
	$scope.goBack = function () {
		$state.go("app.main");
		$ionicViewSwitcher.nextDirection("back");
	};


	//相隔天数
	$scope.daysApart = function () {
		var strSeparator = "-"; //日期分隔
		var oDate1 = $scope.data.startTime.split(strSeparator);
		var oDate2 = $scope.data.endTime.split(strSeparator);
		var strDateS = new Date(oDate1[0], oDate1[1] - 1, oDate1[2]);
		var strDateE = new Date(oDate2[0], oDate2[1] - 1, oDate2[2]);
		var days = parseInt(Math.abs(strDateS - strDateE) / 1000 / 60 / 60 / 24);
		return days;
	};


	$scope.query = function () {
		var daysApart = $scope.daysApart();
		//只能查一个月以内的数据
		if (daysApart <= 31) {
			rootScope.scrollTop("spMainScroll");
			$scope.currPage = 1;
			$scope.commoditySellList = [];
			$scope.loadData();
			return true;
		} else {
			showToast($ionicLoading, '请查询一个月以内的数据');
			return false;
		}
	};

	$scope.selStore = function () {
		rootScope.scrollTop("spMainScroll");
		$scope.selStoreId = $("#selStore").val();
		$scope.currPage = 1;
		$scope.commoditySellList = [];
		$scope.loadData();
	};

	$scope.$on('$ionicView.afterEnter', function() {   
		// if($scope.showSubStores)  {
		// 	$("#mainDiv").height($window.innerHeight - 88);
		// } else {
		// 	$("#mainDiv").height($window.innerHeight - 44);
		// }
		$scope.query();
	});

	$ionicModal.fromTemplateUrl('js/spxs/spxsDetail.html', {
		scope: $scope,
		animation: 'slide-in-up'
	}).then(function (modal) {
		$scope.spxsDetailModal = modal;
	});

	$scope.openspxsDetailModal = function (item) {
		$scope.item = item;
		console.log($scope.item );
		$scope.spxsDetailModal.show();
	};
	$scope.closespxsDetailModal = function () {
		$scope.spxsDetailModal.hide();
	};
	//Cleanup the modal when we're done with it!
	$scope.$on('$destroy', function () {
		$scope.spxsDetailModal.remove();
	});

	$scope.loadData = function () {			
		checkLogin().then(function(result) {
			var dataJson = {
				fromDate: $scope.data.startTime,
				toDate: $scope.data.endTime,
				storeId: $scope.selStoreId,
				cateId: $scope.data.commodityTypeId,
				page: $scope.currPage,
				limit: $scope.pageSize
			};

			showLoading("正在加载数据，请稍后...");

			var url = webHost + 'api/vboss/goodssaleslist';
			$http.post(url, dataJson).success(function(data) {
				$scope.$broadcast('scroll.refreshComplete');
				$scope.$broadcast('scroll.infiniteScrollComplete');
				if (data.records) {
					var g = data.total % $scope.pageSize;
					$scope.totalPage = parseInt(data.total / $scope.pageSize) + (g > 0 ? 1 : 0);

					for (var i = 0; i < data.records.length; i++) {
						$scope.commoditySellList.push(data.records[i]);
					}

					$scope.noData = data.records.length < 1;
				}
			}).error(function(data) {
				$scope.$broadcast('scroll.refreshComplete');
				$scope.$broadcast('scroll.infiniteScrollComplete');
			});
		});
	};
	
	$scope.doRefresh = function () {
		$scope.currPage = 1;
		$scope.commoditySellList = [];
		$scope.loadData();
		$scope.$broadcast('scroll.refreshComplete');
	};

	$scope.loadMore = function () {
		if ($scope.currPage >= $scope.totalPage) {
			$scope.$broadcast('scroll.infiniteScrollComplete');
			return;
		}
		$scope.currPage += 1;
		$scope.loadData();
		$scope.$broadcast('scroll.infiniteScrollComplete');
	};

	$scope.showQuery = function () {
		checkLogin().then(function(result) {
			CommomService.loadCommodityTypes($scope.selStoreId);
		});
		$scope.isShow = !$scope.isShow;
		$scope.showSpxsPopup();
	};

	var spxsPopup = null;
	$scope.showSpxsPopup = function () {
		var commodityTypeId = $scope.data.commodityTypeId;
		var startTime = $scope.data.startTime;
		var endTime = $scope.data.endTime;
		spxsPopup = $ionicPopup.show({
			title: '请选择',
			cssClass: 'vboss_search_popup',
			templateUrl: 'js/spxs/spxs_popup.html',
			scope: $scope,
			buttons: [
				{
					text: '取消',
					type: 'button-cancle',
					onTap: function(e){
					  $scope.data.commodityTypeId = commodityTypeId;
					  $scope.data.startTime = startTime;
					  $scope.data.endTime = endTime;
					  return true;
					}
				},
				{
					text: '确定',
					type: 'button-ok',
					onTap: function(e) {
					  if(!$scope.query()) {
						e.preventDefault();
					  } else {
						  return true;
					  }
					}
				}
			]

		});
		spxsPopup.then(function (res) {
		});
	};

	//主体对象
	$scope.datepickerObjectFrom = {
		inputDate: new Date(Date.parse($scope.data.startTime.replace(/-+/g, '/'))),  //可选，输入值		
		callback: function (val) {  //Mandatory
			if (typeof (val) === 'undefined') {
			} else {
				console.log('Selected date is : ', val);
				$scope.datepickerObjectFrom.inputDate = new Date(val);  //这行官网没有，不设置 的话，选中日期不能回填到页面。
				$scope.data.startTime = $filter('date')(val, 'yyyy-MM-dd');
			}
		}
	};

	$scope.showFromDateDialog = function(){  
		ionicDatePicker.openDatePicker($scope.datepickerObjectFrom); 
	};

	//主体对象
	$scope.datepickerObjectTo = {
		inputDate: new Date(Date.parse($scope.data.endTime.replace(/-+/g, '/'))),  //可选，输入值		
		callback: function (val) {  //Mandatory
			if (typeof (val) === 'undefined') {
			} else {
				console.log('Selected date is : ', val);
				$scope.datepickerObjectTo.inputDate = new Date(val);  //这行官网没有，不设置 的话，选中日期不能回填到页面。
				$scope.data.endTime = $filter('date')(val, 'yyyy-MM-dd');
			}
		}
	};

	$scope.showToDateDialog = function(){  
		ionicDatePicker.openDatePicker($scope.datepickerObjectTo); 
	};

	$scope.sortDataList = [{
		text: '按销售数量排序',
		value: 'wpSellDetailEntity.sellNum'
	}, {
		text: '按销售金额排序',
		value: 'wpSellDetailEntity.totalAmount'
	}];
	$scope.data.sortType = 'wpSellDetailEntity.sellNum';
}
