function xsdjCtrl($ionicViewSwitcher, $scope, $state, $timeout, $http, $ionicModal, $ionicLoading, $ionicPopup, $ionicHistory, CommomService, $filter, ionicDatePicker, $window) {
	$scope.data = {};
	$scope.totalCount = 0;//总数
	$scope.totalPage = 1; //总页数
	$scope.currPage = 1;  //当前页数
	$scope.pageSize = 10;  //页显示条数
	$scope.sellList = [];	
	$scope.data.startTime = rootScope.timeParams;
	$scope.data.endTime = rootScope.timeParams;
	$scope.noData = false;
	
	$scope.seller = loginToken;
	$scope.showSubStores = loginToken.storeType == 2;
	$scope.selStoreId = rootScope.selStoreId;
	$scope.subStoreInfoList = loginToken.subStoreInfoList;
	$scope.salesTypes = salesTypes;
	$scope.salesStatuses = salesStatuses;

	$scope.cHeight = $scope.showSubStores ? hasSubHeight : defaultHeight;

	$scope.$on("$ionicView.leave", function() {
		if(xsdjPopup && xsdjPopup != null) xsdjPopup.close();
		ionicDatePicker.close();
	});
	/*
	 *返回上一页
	 */
	$scope.goBack = function () {
		$state.go("app.main");
		$ionicViewSwitcher.nextDirection("back");
	};
	// $scope.data.startTime = new Date().format("yyyy-MM-dd");
	// $scope.data.endTime = new Date().format("yyyy-MM-dd");

	$scope.loadData = function () {
		
		checkLogin().then(function(result) {
			var dataJson = {
				fromDate: $scope.data.startTime,
				toDate: $scope.data.endTime,
				salesType: $scope.data.sellType,
				status: $scope.data.status,
				storeId: $scope.selStoreId,
				page: $scope.currPage,
				limit: $scope.pageSize
			};

			showLoading("正在加载数据，请稍后...");

			var url = webHost + 'api/vboss/saleslist';

			$http.post(url, dataJson).success(function(data) {
				console.log(data);
				$scope.$broadcast('scroll.refreshComplete');
				$scope.$broadcast('scroll.infiniteScrollComplete');
				if (data.records) {
					var g = data.total % $scope.pageSize;
					console.log(g);
					$scope.totalPage = parseInt(data.total / $scope.pageSize) + (g > 0 ? 1 : 0);
					console.log($scope.totalPage);

					for (var i = 0; i < data.records.length; i++) {
						$scope.sellList.push(data.records[i]);
					}

					$scope.noData = $scope.sellList.length < 1;
				}
			}).error(function(data) {
				$scope.$broadcast('scroll.refreshComplete');
				$scope.$broadcast('scroll.infiniteScrollComplete');
			});

		});

	};

	$scope.loadSellDetail = function () {

		checkLogin().then(function(result) {

			showLoading("正在加载数据，请稍后...");

			var dataJson = {
				storeId: $scope.selStoreId,
				salesId: $scope.item.id,
				custId:  !$scope.item.custId ? '' : $scope.item.custId
			};
			
			var url = webHost + 'api/vboss/salesdetail';
			$http.post(url, dataJson).success(function(data) {
				console.log(data);
				if (data.code == 0) {
					$scope.sellDetailList = data.data.salesdetail;
					var orderBy = $filter('orderBy');
					$scope.payDetailList = orderBy(data.data.salespays, '-payName', true);

					if(data.data.customer) {
						$scope.item.custCode = data.data.customer.custCode;
						$scope.item.custName = data.data.customer.custName;
					}
					var costAmt = 0.00;
					var totalAmt = 0.00;
					for(var i=0; i< $scope.sellDetailList.length; i++) {
						costAmt += $scope.sellDetailList[i].salesQty * $scope.sellDetailList[i].costPrice;
						totalAmt += $scope.sellDetailList[i].salesAmt;
					}
					if($scope.item.salesType == 'R' || $scope.item.salesType == 'V') {
						$scope.item.costAmt = 0;
						$scope.item.gainAmt = 0;
						$scope.item.discount = 0;
						$scope.item.rechangeAmt = 0;
					} else {
						$scope.item.costAmt = costAmt;
						$scope.item.gainAmt = $scope.item.salesAmt - costAmt;
						var tmpDis = ($scope.item.salesAmt / $scope.item.retailAmt) * 100;
						if(tmpDis > 100) {
							tmpDis = 100;
						}
						$scope.item.discount = tmpDis;
						$scope.item.rechangeAmt = totalAmt - $scope.item.salesAmt;
					}
					console.log($scope.sellDetailList);
				}
			});
		});
	};
	
	$scope.$on('$ionicView.afterEnter', function() {     
		// if($scope.showSubStores)  {
		// 	$("#mainDiv").height($window.innerHeight - 49);        
		// } else {
		// 	$("#mainDiv").height($window.innerHeight - 5);
		// }
		$scope.query();
	});

	$scope.query = function () {
		rootScope.scrollTop("xsMainScroll");
		$scope.currPage = 1;
		$scope.sellList = [];
		$scope.loadData();
	};

	$scope.selStore = function () {		
		rootScope.scrollTop("xsMainScroll");
		$scope.selStoreId = $("#selStore").val();
		$scope.currPage = 1;
		$scope.sellList = [];
		$scope.loadData();
	};

	$ionicModal.fromTemplateUrl('js/xsdj/xsdjDetail.html', {
		scope: $scope,
		animation: 'slide-in-up'
	}).then(function (modal) {
		$scope.sellInfoModal = modal;
	});

	$scope.openSellInfoModal = function (item) {
		$scope.item = item;
		console.log($scope.item);
		$scope.loadSellDetail();
		rootScope.scrollTop('xsDetailScroll');
		$scope.sellInfoModal.show();
	};

	$scope.closeSellInfoModal = function () {
		$scope.sellInfoModal.hide();
	};

	//Cleanup the modal when we're done with it!
	$scope.$on('$destroy', function () {
		$scope.sellInfoModal.remove();
	});

	$scope.loadMore = function () {
		if ($scope.currPage >= $scope.totalPage) {
			$scope.$broadcast('scroll.infiniteScrollComplete');
			return;
		}
		$scope.currPage += 1;
		$scope.loadData();
		$scope.$broadcast('scroll.infiniteScrollComplete');
	};

	$scope.doRefresh = function () {
		$scope.currPage = 1;
		$scope.sellList = [];
		$scope.loadData();
		$scope.$broadcast('scroll.refreshComplete');
	};

	$scope.selStoreInfo = function (item) {
		$scope.selStoreName = item.storeName;
		$scope.selStoreId = item.id;
		$scope.loadData();
	};

	$scope.showQuery = function () {
		checkLogin().then(function(result) {
			CommomService.loadEmployees($scope.selStoreId, 'C');
		});

		if ($scope.isShow) {
			$scope.isShow = false;
		} else {
			$scope.isShow = true;
		}
		$scope.showXsdjPopup();
	};

	var xsdjPopup = null;
	$scope.showXsdjPopup = function () {
		var employeeId = $scope.data.employeeId;
		var startTime = $scope.data.startTime;
		var endTime = $scope.data.endTime;
		var sellType = $scope.data.sellType;
		var status = $scope.data.status;
		xsdjPopup = $ionicPopup.show({
			title: '请选择',
			cssClass: 'vboss_search_popup',
			templateUrl: 'js/xsdj/xsdj_popup.html',
			scope: $scope,
			buttons: [
				{
					text: '取消',
					type: 'button-cancle',
					onTap: function(e){
					  $scope.data.employeeId = employeeId;
					  $scope.data.startTime = startTime;
					  $scope.data.endTime = endTime;
					  $scope.data.sellType = sellType;
					  $scope.data.status = status;
					  return true;
					}
				},
				{
					text: '确定',
					type: 'button-ok',
					onTap: function(e) {
					  $scope.query();
					  return true;
					}
				}
			]
		});
		xsdjPopup.then(function (res) {
		});
	};

	//主体对象
	$scope.datepickerObjectFrom = {
		inputDate: new Date(Date.parse($scope.data.startTime.replace(/-+/g, '/'))),  //可选，输入值		
		callback: function (val) {  //Mandatory
			if (typeof (val) === 'undefined') {
			} else {
				console.log('Selected date is : ', val);
				$scope.datepickerObjectFrom.inputDate = new Date(val);  //这行官网没有，不设置 的话，选中日期不能回填到页面。
				$scope.data.startTime = $filter('date')(val, 'yyyy-MM-dd');
			}
		}
	};

	$scope.showFromDateDialog = function() {
		ionicDatePicker.openDatePicker($scope.datepickerObjectFrom); 
	};

	//主体对象
	$scope.datepickerObjectTo = {
		inputDate: new Date(Date.parse($scope.data.endTime.replace(/-+/g, '/'))),  //可选，输入值		
		callback: function (val) {  //Mandatory
			if (typeof (val) === 'undefined') {
			} else {
				console.log('Selected date is : ', val);
				$scope.datepickerObjectTo.inputDate = new Date(val);
				$scope.data.endTime = $filter('date')(val, 'yyyy-MM-dd');
			}
		}
	};

	$scope.showToDateDialog = function(){  
		ionicDatePicker.openDatePicker($scope.datepickerObjectTo); 
	};

	$scope.showPageContent = function () {
		return $scope.totalPage > 1;
	};

	$scope.data.isShowDJDetail = false;
	$scope.showDJDetail = function () {
		$scope.data.isShowDJDetail = !$scope.data.isShowDJDetail;
	};
}
