function yyhzCtrl($ionicViewSwitcher, $scope, $state, $timeout, $http, $ionicLoading, CommomService, $ionicHistory, $filter, $ionicScrollDelegate, ionicDatePicker, MonthPicker) {
	
	$scope.sy = "当日收益";

	$scope.choose = true;
	$scope.currentTime = rootScope.timeParams;
	$scope.currentMonth = $filter("date")(rootScope.timeParams, 'yyyy-MM');
	$scope.seller = loginToken;
	$scope.showSubStores = loginToken.storeType == 2;
	$scope.selStoreId = rootScope.selStoreId;
	$scope.subStoreInfoList = loginToken.subStoreInfoList;
	$scope.hasDetail = true;
	$scope.salesList = [];
	$scope.voidList = [];
	$scope.returnList = [];
	$scope.rechargeList = [];

	$scope.cHeight = $scope.showSubStores ? hasSubHeight + 30: defaultHeight + 30;

	$scope.$on('$ionicView.afterEnter', function() {            
		$scope.init();
	});

	$scope.$on("$ionicView.leave", function() {
		ionicDatePicker.close();
		MonthPicker.close();
	});

	$scope.selStore = function () {
		$scope.selStoreId = $("#selStore").val();
		if($scope.selStoreId == '') {
			$scope.hasDetail = false;
		} else {
			$scope.hasDetail = $scope.choose;
		}
		$scope.init();		
	};

	$scope.doRefresh = function () {
		$scope.init();
		$scope.$broadcast('scroll.refreshComplete');
	};

	$scope.init = function () {

		checkLogin().then(function(result) {

			var jsonData = {};

			$scope.salesList = [];
			$scope.voidList = [];
			$scope.returnList = [];
			$scope.rechargeList = [];

			var url = webHost;

			if ($scope.choose) {
				url += 'api/vboss/dailysales';
				jsonData = {
					storeId: $scope.selStoreId,
					dateStr: $scope.currentTime,
					model: 0
				};
			} else {
				url += 'api/vboss/monthlysales';
				jsonData = {
					storeId: $scope.selStoreId,
					monthStr: $scope.currentMonth
				};
			}

			showLoading("正在加载数据，请稍后...");
			
			$http.post(url, jsonData).success(function(data) {

				console.log(data);
				$scope.$broadcast('scroll.refreshComplete');
				if (data.code == 0) {					
					$scope.totalAmt = data.data.salesCount.salesAmt + data.data.returnCount.salesAmt + data.data.voidCount.salesAmt;
					$scope.gainAmt = data.data.salesCount.gainAmt + data.data.returnCount.gainAmt + data.data.voidCount.gainAmt;
					$scope.salesNum = data.data.salesCount.salesNum + data.data.returnCount.salesNum + data.data.voidCount.salesNum;
					$scope.voidAmt = data.data.voidCount.salesAmt;
					$scope.rechargeAmt = data.data.rechargeCount.rechargeAmt;						
					$scope.returnAmt = data.data.returnCount.salesAmt;				
					// if($scope.choose) {
					// 	$scope.salesList = data.data.salesList;
					// 	$scope.voidList = data.data.voidList;
					// 	$scope.returnList = data.data.returnList;
					// 	$scope.rechargeList = data.data.rechargeList;
					// }
				}
			}).error(function(data) {
				$scope.$broadcast('scroll.refreshComplete');
			});
		});

	};

	$scope.goBack = function () {
		$state.go("app.main");
		$ionicViewSwitcher.nextDirection("back");
	};

	//本月
	$scope.showyyls = function () {
		//$("#yyls").hide();
		$("#today").css({"background-color": "#FFFFFF", "color": "#007fdb", "border": "1px solid #007fdb"});
		$("#thisMonth").css({"background-color": "#387ef5", "color": "#ffffff"});
		console.log($scope.currentMonth);
		$scope.sy = "当月收益";
		$scope.choose = false;
		$scope.init();
		//console.log('本月---' + $scope.timeParams);
	};

	//今日
	$scope.showyyls2 = function () {
		//$("#yyls").show();
		$("#today").css({"background-color": "#387ef5", "color": "#ffffff"});
		$("#thisMonth").css({"background-color": "#FFFFFF", "color": "#007fdb", "border": "1px solid #007fdb"});
		$scope.sy = "当日收益";
		$scope.choose = true;
		$scope.init();
		//console.log('今日---' + $scope.timeParams);
	};


	$scope.preDay = function () {
		$ionicScrollDelegate.$getByHandle('infoMainScroll').scrollTop();
		if ($scope.choose) {
			var before = $scope.currentTime;
			before = getYestoday(before);
		} else {
			var before = $scope.currentMonth;
			before = getPreMonth(before);
			console.log(before);
		}
		if($scope.choose) {
			$scope.currentTime = before;
		}else{
			$scope.currentMonth = before;
		}
		$scope.init();
		$("#yy-left").css({"font-size": "28px"});
		$("#yy-right").css({"font-size": "22px"});
	}

	$scope.nextDay = function () {
		$ionicScrollDelegate.$getByHandle('infoMainScroll').scrollTop();
		if ($scope.choose) {
			var aa = new Date().format('yyyy-MM-dd');
			var later = $scope.currentTime;
			later = getNextday(later);
		} else {
			var aa = new Date().format('yyyy-MM');
			var later = $scope.currentMonth;
			later = getNextMonth(later);
			console.log(later);
		}
		if (later > aa) {
			showToast($ionicLoading, '此日期不能选择!');
		} else {
			if($scope.choose) {
				$scope.currentTime = later;
			}else{
				$scope.currentMonth = later;
			}
			$scope.init();
		}
		$("#yy-left").css({"font-size": "22px"});
		$("#yy-right").css({"font-size": "28px"});
	}

	$scope.monthPickerOptions = {
		minYear : new Date().getFullYear() - 10,
		maxYear : new Date().getFullYear(),	
		inputYear: new Date().getFullYear(),
		inputMonth: new Date().getMonth(),
        title : '选择月份',  
        cancelText : '关闭',  
        monthLabels : ['一月','二月','三月','四月','五月','六月','七月','八月','九月','十月','十一月','十二月']  
    };  
    MonthPicker.init($scope.monthPickerOptions);
  
    //弹出选择月份  
    $scope.showMonthDialog = function(myevent){  
		//res为json对象，有year和month两个key  
		$scope.monthPickerOptions.inputYear = eval($scope.currentMonth.substr(0, 4));
		$scope.monthPickerOptions.inputMonth = eval($scope.currentMonth.substr(5)) - 1;
        MonthPicker.show($scope.monthPickerOptions, function(res) {
			$scope.monthPickerOptions.inputYear = res.year;
			$scope.monthPickerOptions.inputMonth = res.month;
			if(res.month+1 < 10) {
				$scope.currentMonth = res.year+"-0"+(res.month+1);
			} else {
				$scope.currentMonth = res.year+"-"+(res.month+1);
			}
			$scope.init();
        });  
    }; 

	//主体对象
	$scope.datepickerObjectEnd = {
		inputDate: new Date(),  //可选，输入值		
		callback: function (val) {  //Mandatory
			if (typeof (val) === 'undefined') {
			} else {
				console.log('Selected date is : ', val);
				$scope.datepickerObjectEnd.inputDate = new Date(val);  //这行官网没有，不设置 的话，选中日期不能回填到页面。
				$scope.currentTime = $filter('date')(val, 'yyyy-MM-dd');
				$scope.timeParams = $scope.currentTime;
				$scope.init();
			}
		}
	};

	$scope.showDateDialog = function() {  
		$scope.datepickerObjectEnd.inputDate = new Date(Date.parse($scope.currentTime.replace(/-+/g, '/')));
		ionicDatePicker.openDatePicker($scope.datepickerObjectEnd); 
	};


	$scope.oldIndex = 0;
	$scope.xdetail1 = true;
	$scope.showDetail = function (index) {
		showLoading("正在加载数据，请稍后...");
		if (index == 1) {
			if ($scope.oldIndex == index) {
				$scope.xdetail1 = true;
			} else {
				$scope.xdetail1 = true;
			}
			$scope.xdetail2 = false;
			$scope.xdetail3 = false;
			$scope.xdetail4 = false;

			$("#x1").addClass("selTab").removeClass("noSelTab");
			$("#x2").removeClass("selTab").addClass("noSelTab");
			$("#x3").removeClass("selTab").addClass("noSelTab");
			$("#x4").removeClass("selTab").addClass("noSelTab");
		} else if (index == 2) {
			if ($scope.oldIndex == index) {
				$scope.xdetail2 = true;
			} else {
				$scope.xdetail2 = true;
			}
			$scope.xdetail1 = false;
			$scope.xdetail3 = false;
			$scope.xdetail4 = false;

			$("#x1").removeClass("selTab").addClass("noSelTab");
			$("#x2").addClass("selTab").removeClass("noSelTab");
			$("#x3").removeClass("selTab").addClass("noSelTab");
			$("#x4").removeClass("selTab").addClass("noSelTab");
		} else if (index == 3) {
			if ($scope.oldIndex == index && $scope.xdetail3) {
				$scope.xdetail3 = true;
			} else {
				$scope.xdetail3 = true;
			}
			$scope.xdetail1 = false;
			$scope.xdetail2 = false;
			$scope.xdetail4 = false;


			$("#x1").removeClass("selTab").addClass("noSelTab");
			$("#x2").removeClass("selTab").addClass("noSelTab");
			$("#x3").addClass("selTab").removeClass("noSelTab");
			$("#x4").removeClass("selTab").addClass("noSelTab");

	
		} else if (index == 4) {
			if ($scope.oldIndex == index && $scope.xdetail4) {
				$scope.xdetail4 = true;
			} else {
				$scope.xdetail4 = true;
			}
			$scope.xdetail1 = false;
			$scope.xdetail2 = false;
			$scope.xdetail3 = false;

			$("#x1").removeClass("selTab").addClass("noSelTab");
			$("#x2").removeClass("selTab").addClass("noSelTab");
			$("#x3").removeClass("selTab").addClass("noSelTab");
			$("#x4").addClass("selTab").removeClass("noSelTab");
		}

		$scope.oldIndex = index;

		$timeout(function () {
			rootScope.scrollTop("infoMainScroll");
			hideLoading();
		}, 500);
	};
}
